 // [jO MURACO
#undef  structClear
#define structClear(bodystruct)     (memset(&(bodystruct),0,(UINT)sizeof(bodystruct)))

#define HIST_BINARYLIST     ((HHIST)"mrcBinaryListHist")
#define HIST_ENTRYPATHLIST  ((HHIST)"pwzFilerPathlist")

#define NM_DBLCLK    (-3)
#define UWM_NOTICECHANGE        (WM_TXUSER + 102)

#define SBMAXSIZE               4096

#define IDCCMDMAX               7
#define IDC_LISTVIEW            1000
#define IDC_CMDADD              1001
#define IDC_CMDEDIT             1002
#define IDC_CMDDELETE           1003
#define IDC_CMDSORT1            1004
#define IDC_CMDSORT2            1005

#define LVS_ICON                0x0000
#define LVS_REPORT              0x0001
#define LVS_SMALLICON           0x0002
#define LVS_LIST                0x0003
#define LVS_TYPEMASK            0x0003
#define LVS_SINGLESEL           0x0004
#define LVS_SHOWSELALWAYS       0x0008
#define LVS_SORTASCENDING       0x0010
#define LVS_SORTDESCENDING      0x0020
#define LVS_SHAREIMAGELISTS     0x0040
#define LVS_NOLABELWRAP         0x0080
#define LVS_AUTOARRANGE         0x0100
#define LVS_EDITLABELS          0x0200
#define LVS_OWNERDATA           0x1000
#define LVS_NOSCROLL            0x2000
#define LVS_TYPESTYLEMASK       0xfc00
#define LVS_ALIGNTOP            0x0000
#define LVS_ALIGNLEFT           0x0800
#define LVS_ALIGNMASK           0x0c00
#define LVS_OWNERDRAWFIXED      0x0400
#define LVS_NOCOLUMNHEADER      0x4000
#define LVS_NOSORTHEADER        0x8000

#define LVS_EX_GRIDLINES        0x00000001
#define LVS_EX_SUBITEMIMAGES    0x00000002
#define LVS_EX_CHECKBOXES       0x00000004
#define LVS_EX_TRACKSELECT      0x00000008
#define LVS_EX_HEADERDRAGDROP   0x00000010
#define LVS_EX_FULLROWSELECT    0x00000020 // applies to report mode only
#define LVS_EX_ONECLICKACTIVATE 0x00000040
#define LVS_EX_TWOCLICKACTIVATE 0x00000080
#define LVS_EX_FLATSB           0x00000100
#define LVS_EX_REGIONAL         0x00000200
#define LVS_EX_INFOTIP          0x00000400 // listview does InfoTips for you
#define LVS_EX_UNDERLINEHOT     0x00000800
#define LVS_EX_UNDERLINECOLD    0x00001000
#define LVS_EX_MULTIWORKAREAS   0x00002000

#define LVN_FIRST               (0U-100U)       // listview
#define LVN_LAST                (0U-199U)
#define LVN_ITEMCHANGING        (LVN_FIRST-0)
#define LVN_ITEMCHANGED         (LVN_FIRST-1)
#define LVN_INSERTITEM          (LVN_FIRST-2)
#define LVN_DELETEITEM          (LVN_FIRST-3)
#define LVN_DELETEALLITEMS      (LVN_FIRST-4)
#define LVN_BEGINLABELEDITA     (LVN_FIRST-5)
#define LVN_BEGINLABELEDITW     (LVN_FIRST-75)
#define LVN_ENDLABELEDITA       (LVN_FIRST-6)
#define LVN_ENDLABELEDITW       (LVN_FIRST-76)
#define LVN_COLUMNCLICK         (LVN_FIRST-8)
#define LVN_BEGINDRAG           (LVN_FIRST-9)
#define LVN_BEGINRDRAG          (LVN_FIRST-11)
#define LVN_ODCACHEHINT         (LVN_FIRST-13)
#define LVN_ODFINDITEMA         (LVN_FIRST-52)
#define LVN_ODFINDITEMW         (LVN_FIRST-79)
#define LVN_ITEMACTIVATE        (LVN_FIRST-14)
#define LVN_ODSTATECHANGED      (LVN_FIRST-15)
#define LVN_ODFINDITEM          LVN_ODFINDITEMA
#define LVN_HOTTRACK            (LVN_FIRST-21)
#define LVN_GETDISPINFOA        (LVN_FIRST-50)
#define LVN_SETDISPINFOA        (LVN_FIRST-51)
#define LVN_KEYDOWN             (LVN_FIRST-55)

#define LVN_BEGINLABELEDIT      LVN_BEGINLABELEDITA
#define LVN_ENDLABELEDIT        LVN_ENDLABELEDITA
#define LVN_GETDISPINFO         LVN_GETDISPINFOA
#define LVN_SETDISPINFO         LVN_SETDISPINFOA

#define LVCF_FMT                0x0001
#define LVCF_WIDTH              0x0002
#define LVCF_TEXT               0x0004
#define LVCF_SUBITEM            0x0008
#define LVCF_IMAGE              0x0010
#define LVCF_ORDER              0x0020

#define LVIS_FOCUSED            0x0001
#define LVIS_SELECTED           0x0002
#define LVIS_CUT                0x0004
#define LVIS_DROPHILITED        0x0008
#define LVIS_ACTIVATING         0x0020
#define LVIS_OVERLAYMASK        0x0F00
#define LVIS_STATEIMAGEMASK     0xF000

#define LVIF_TEXT               0x0001
#define LVIF_IMAGE              0x0002
#define LVIF_PARAM              0x0004
#define LVIF_STATE              0x0008
#define LVIF_INDENT             0x0010
#define LVIF_NORECOMPUTE        0x0800

#define LVFI_PARAM              0x0001
#define LVFI_STRING             0x0002
#define LVFI_PARTIAL            0x0008
#define LVFI_WRAP               0x0020
#define LVFI_NEARESTXY          0x0040

#define LVCFMT_LEFT             ((int)0x0000)
#define LVCFMT_RIGHT            ((int)0x0001)
#define LVCFMT_CENTER           ((int)0x0002)
#define LVCFMT_JUSTIFYMASK      ((int)0x0003)
#define LVCFMT_IMAGE            ((int)0x0800)
#define LVCFMT_BITMAP_ON_RIGHT  ((int)0x1000)
#define LVCFMT_COL_HAS_IMAGES   ((int)0x8000)

#define LVNI_ALL                0x0000
#define LVNI_FOCUSED            0x0001
#define LVNI_SELECTED           0x0002
#define LVNI_CUT                0x0004
#define LVNI_DROPHILITED        0x0008

#define LVNI_ABOVE              0x0100
#define LVNI_BELOW              0x0200
#define LVNI_TOLEFT             0x0400
#define LVNI_TORIGHT            0x0800

#define LVM_FIRST               0x1000      // ListView messages

// Xgr[
#define LVM_GETITEMCOUNT                (LVM_FIRST + 4)
#define LVM_GETITEMA                    (LVM_FIRST + 5)
#define LVM_SETITEMA                    (LVM_FIRST + 6)
#define LVM_INSERTITEMA                 (LVM_FIRST + 7)
#define LVM_DELETEITEM                  (LVM_FIRST + 8)
#define LVM_GETNEXTITEM                 (LVM_FIRST + 12)
#define LVM_FINDITEMA                   (LVM_FIRST + 13)
#define LVM_GETCOLUMNA                  (LVM_FIRST + 25)
#define LVM_SETCOLUMNA                  (LVM_FIRST + 26)
#define LVM_INSERTCOLUMNA               (LVM_FIRST + 27)
#define LVM_GETHEADER                   (LVM_FIRST + 31)
#define LVM_SETITEMSTATE                (LVM_FIRST + 43)
#define LVM_GETITEMSTATE                (LVM_FIRST + 44)
#define LVM_GETITEMTEXTA                (LVM_FIRST + 45)
#define LVM_SETITEMTEXTA                (LVM_FIRST + 46)
#define LVM_SORTITEMS                   (LVM_FIRST + 48)
#define LVM_SETEXTENDEDLISTVIEWSTYLE    (LVM_FIRST + 54)   // optional wParam == mask
#define LVM_GETEXTENDEDLISTVIEWSTYLE    (LVM_FIRST + 55)

#define HDM_FIRST               0x1200      // Header messages
#define HDM_GETITEMCOUNT        (HDM_FIRST + 0)

#if 0   // gpbZ[W
#define LVM_GETBKCOLOR                  (LVM_FIRST + 0)
#define LVM_SETBKCOLOR                  (LVM_FIRST + 1)
#define LVM_GETIMAGELIST                (LVM_FIRST + 2)
#define LVM_SETIMAGELIST                (LVM_FIRST + 3)
#define LVM_DELETEALLITEMS              (LVM_FIRST + 9)
#define LVM_GETCALLBACKMASK             (LVM_FIRST + 10)
#define LVM_SETCALLBACKMASK             (LVM_FIRST + 11)
#define LVM_GETITEMRECT                 (LVM_FIRST + 14)
#define LVM_SETITEMPOSITION             (LVM_FIRST + 15)
#define LVM_GETITEMPOSITION             (LVM_FIRST + 16)
#define LVM_GETSTRINGWIDTHA             (LVM_FIRST + 17)
#define LVM_HITTEST                     (LVM_FIRST + 18)
#define LVM_ENSUREVISIBLE               (LVM_FIRST + 19)
#define LVM_SCROLL                      (LVM_FIRST + 20)
#define LVM_REDRAWITEMS                 (LVM_FIRST + 21)
#define LVM_ARRANGE                     (LVM_FIRST + 22)
#define LVM_EDITLABELA                  (LVM_FIRST + 23)
#define LVM_GETEDITCONTROL              (LVM_FIRST + 24)
#define LVM_DELETECOLUMN                (LVM_FIRST + 28)
#define LVM_GETCOLUMNWIDTH              (LVM_FIRST + 29)
#define LVM_SETCOLUMNWIDTH              (LVM_FIRST + 30)
#define LVM_CREATEDRAGIMAGE             (LVM_FIRST + 33)
#define LVM_GETVIEWRECT                 (LVM_FIRST + 34)
#define LVM_GETTEXTCOLOR                (LVM_FIRST + 35)
#define LVM_SETTEXTCOLOR                (LVM_FIRST + 36)
#define LVM_GETTEXTBKCOLOR              (LVM_FIRST + 37)
#define LVM_SETTEXTBKCOLOR              (LVM_FIRST + 38)
#define LVM_GETTOPINDEX                 (LVM_FIRST + 39)
#define LVM_GETCOUNTPERPAGE             (LVM_FIRST + 40)
#define LVM_GETORIGIN                   (LVM_FIRST + 41)
#define LVM_UPDATE                      (LVM_FIRST + 42)
#define LVM_SETITEMCOUNT                (LVM_FIRST + 47)
#define LVM_SETITEMPOSITION32           (LVM_FIRST + 49)
#define LVM_GETSELECTEDCOUNT            (LVM_FIRST + 50)
#define LVM_GETITEMSPACING              (LVM_FIRST + 51)
#define LVM_GETISEARCHSTRINGA           (LVM_FIRST + 52)
#define LVM_SETICONSPACING              (LVM_FIRST + 53)
#define LVM_GETSUBITEMRECT              (LVM_FIRST + 56)
#define LVM_SUBITEMHITTEST              (LVM_FIRST + 57)
#define LVM_SETCOLUMNORDERARRAY         (LVM_FIRST + 58)
#define LVM_GETCOLUMNORDERARRAY         (LVM_FIRST + 59)
#define LVM_SETHOTITEM                  (LVM_FIRST + 60)
#define LVM_GETHOTITEM                  (LVM_FIRST + 61)
#define LVM_SETHOTCURSOR                (LVM_FIRST + 62)
#define LVM_GETHOTCURSOR                (LVM_FIRST + 63)
#define LVM_APPROXIMATEVIEWRECT         (LVM_FIRST + 64)
#define LVM_SETWORKAREAS                (LVM_FIRST + 65)
#define LVM_GETSELECTIONMARK            (LVM_FIRST + 66)
#define LVM_SETSELECTIONMARK            (LVM_FIRST + 67)
#define LVM_SETBKIMAGEA                 (LVM_FIRST + 68)
#define LVM_GETBKIMAGEA                 (LVM_FIRST + 69)
#define LVM_GETWORKAREAS                (LVM_FIRST + 70)
#define LVM_SETHOVERTIME                (LVM_FIRST + 71)
#define LVM_GETHOVERTIME                (LVM_FIRST + 72)
#define LVM_GETNUMBEROFWORKAREAS        (LVM_FIRST + 73)
#define LVM_SETTOOLTIPS                 (LVM_FIRST + 74)
#define LVM_GETITEMW                    (LVM_FIRST + 75)
#define LVM_SETITEMW                    (LVM_FIRST + 76)
#define LVM_INSERTITEMW                 (LVM_FIRST + 77)
#define LVM_GETTOOLTIPS                 (LVM_FIRST + 78)


#define LVM_FINDITEMW                   (LVM_FIRST + 83)
#define LVM_GETSTRINGWIDTHW             (LVM_FIRST + 87)
#define LVM_GETCOLUMNW                  (LVM_FIRST + 95)
#define LVM_SETCOLUMNW                  (LVM_FIRST + 96)
#define LVM_INSERTCOLUMNW               (LVM_FIRST + 97)
#define LVM_GETITEMTEXTW                (LVM_FIRST + 115)
#define LVM_SETITEMTEXTW                (LVM_FIRST + 116)
#define LVM_GETISEARCHSTRINGW           (LVM_FIRST + 117)
#define LVM_EDITLABELW                  (LVM_FIRST + 118)
#define LVM_SETBKIMAGEW                 (LVM_FIRST + 138)
#define LVM_GETBKIMAGEW                 (LVM_FIRST + 139)
#endif

typedef struct tagLVCOLUMNA
{
    UINT mask;
    int fmt;
    int cx;
    LPSTR pszText;
    int cchTextMax;
    int iSubItem;
#if (_WIN32_IE >= 0x0300)
    int iImage;
    int iOrder;
#endif
} LVCOLUMNA, FAR* LPLVCOLUMNA;

#define LVCOLUMN         LVCOLUMNA
#define LPLVCOLUMN       LPLVCOLUMNA

typedef struct tagLVITEMA
{
    UINT mask;
    int iItem;
    int iSubItem;
    UINT state;
    UINT stateMask;
    LPSTR pszText;
    int cchTextMax;
    int iImage;
    LPARAM lParam;
#if (_WIN32_IE >= 0x0300)
    int iIndent;
#endif
} LVITEMA, FAR* LPLVITEMA;

#define LVITEM    LVITEMA
#define LPLVITEM  LPLVITEMA

typedef struct tagNMLISTVIEW
{
    NMHDR   hdr;
    int     iItem;
    int     iSubItem;
    UINT    uNewState;
    UINT    uOldState;
    UINT    uChanged;
    POINT   ptAction;
    LPARAM  lParam;
} NMLISTVIEW, FAR *LPNMLISTVIEW;

typedef struct tagLVFINDINFO {
    UINT    flags;         // ̃^CvtO
    LPCTSTR psz;           // ̃AhX
    LPARAM  lParam;        // ACe̎32rbgl
    POINT   pt;            // ACëʒu
    UINT    vkDirection;   // zL[R[h
} LVFINDINFO, FAR* LPFINDINFO;

typedef struct tagLVKEYDOWN
{
    NMHDR hdr;
    WORD wVKey;
    UINT flags;
} NMLVKEYDOWN, FAR *LPNMLVKEYDOWN;

// p̍\
typedef struct _mconfig
{
    BBOOL   fHistFile;
    BBOOL   fHistFolder;
    BBOOL   fFolderList;
    BBOOL   fSaveWarning;
    BBOOL   fDriveMenu;
    BBOOL   fUIOpenVz;
} MCONFIG;

typedef struct _sortparam
{
} SORTPARAM, *LPSORTPARAM;

typedef struct _mlvdata
{
    HWND        hWnd;       // _CAÕnh
    HWND        hList;      // Xgr[̃nh
    long        iSortClm;   // Ώۂ̗
    long        fWay;       // \[g(0:\[gȂ,1:,2:~)
    long       *pidCmdID;     // {^̂hcz
    long        nCmdID;     // {^̂hc̐
    HHIST       hHist;      // \qXg
    mchar      *pszResult;    // It@CpXԂ߂̃obt@
    char       *pszAdd;     // ǉ{^̃ftHg\pX(NULLs)
    long        nColumn;
} MLVDATA, *LPMLVDATA;

// ݒ̓Ǎ^ۑ
static void cmdGetsetConfig( BOOL fSet, HWND hwnd, MCONFIG *mc );

// R}h֘A
BOOL uiOpenHist_ListView( char *pTitle, HHIST hHist, char *pszfile, char *pszAdd, BYTE *clm, BYTE *way );
static HOOKRESULT WarningMessageAtSave( HWND hwnd, TX *text );

// _CAO
BOOL CALLBACK dlgprocHistFile( HWND hwnd, UINT message, WPARAM wParam, LPARAM lParam );
BOOL InitListView( LPMLVDATA pmlv );
BOOL ResizeClientArea( LPMLVDATA pmlv );
BOOL CommandProc_OK( LPMLVDATA pmlv );
BOOL CommandProc_Delete( LPMLVDATA pmlv );
BOOL CommandProc_Add( LPMLVDATA pmlv );
BOOL CommandProc_Edit( LPMLVDATA pmlv );

#ifndef _FILER   // FILEȐꍇ͕sv
// t@CI[v
static BOOL OpenEditorSetActive( wchar *wszfilename );
#endif

// mrcfiler.txeN֘A
static BOOL OpenMrcFiler( HWND hwnd, wchar *wszpathname, wchar *wszfilename );
static BOOL UnregisterDlgSubClass( void );

// Xgr[
BOOL SortListView( LPMLVDATA pmlv );
BOOL SetColumnSortText( LPMLVDATA pmlv );
int CompareFunc_Sub( LPARAM lParam1, LPARAM lParam2, HWND, long, long );
int CALLBACK CompareFunc( LPARAM lParam1, LPARAM lParam2, LPARAM lParamSort );

// qXg̈Ⴂɂ񐔂Ȃǂ̈Ⴂz
long GetSelectFilename( HWND hwnd, char *pFile, long nColumn );
long InsertItemText( HWND hListView, long idx, char *pFile, long nColumn );
long SetItemText( HWND hListView, long idx, char *pFile, long nColumn );

// Xgr[𑀍삷邾̉ʊ֐
long SetCursorIndex( HWND hListView, long idx );
long GetCursorIndex( HWND hListView );
long SetSubItemText( HWND hListView, long idx, long iSubItem, char *pStr );
BOOL GetSubItemText( HWND hListView, long idx, long iSubItem, char *pStr, long nStr );
BOOL SetItemData( HWND hListView, long idx, long lParam );
long GetItemData( HWND hListView, long idx );
long GetColumnCount( HWND hListView );
long GetFindIndexFromData( HWND hListView, long lParam );
BOOL RefreshItemData( HWND hListView );

BOOL CloseHistoryEverything( HHIST hHist, HSTRBLK sb );
HSTRBLK OpenHistoryEverything( HHIST hHist );

//BOOL CALLBACK EnumWindowProc( HWND hwnd, LPARAM uMsg );
//static BOOL NoticeAllEditor( HWND );

#ifdef __WINNT__
#define myShellExecuteW(a,b,c,d,e,f)                ShellExecuteW(a,b,c,d,e,f)
#define myCreateProcessW(a,b,c,d,e,f,g,h,i,j)       CreateProcessW(a,b,c,d,e,f,g,h,i,j)
#define myGetModuleFileNameW(a,b,c)                 GetModuleFileNameW(a,b,c)
#else
static HINSTANCE myShellExecuteW( HWND P1, wchar *P2, wchar *P3, wchar *P4, wchar *P5, int P6 );
static BOOL myCreateProcessW( wchar *wszP1, wchar *wszP2, LPVOID P3, LPVOID P4,BOOL P5, DWORD P6, LPVOID P7, wchar *wszP8, LPVOID P9, LPVOID P10 );
static DWORD myGetModuleFileNameW( HMODULE P1, wchar *wszP2, DWORD P3 );
#endif

