﻿Imports System
Imports System.Text
Imports System.Runtime.InteropServices

Module ExtCmdModule

    Public Structure SECURITY_ATTRIBUTES
        Public nLength As Integer
        Public lpSecurityDescriptor As Integer
        Public bInheritHandle As Integer
    End Structure

    ' AUTO版 GetPrivateProfileString
    Public Declare Auto Function GetPrivateProfileString Lib "kernel32" _
        Alias "GetPrivateProfileString" ( _
        <MarshalAs(UnmanagedType.LPTStr)> ByVal lpApplicationName As String, _
        <MarshalAs(UnmanagedType.LPTStr)> ByVal lpKeyName As String, _
        <MarshalAs(UnmanagedType.LPTStr)> ByVal lpDefault As String, _
        <MarshalAs(UnmanagedType.LPTStr)> ByVal lpReturnedString As StringBuilder, _
        ByVal nSize As UInt32, _
        <MarshalAs(UnmanagedType.LPTStr)> ByVal lpFileName As String) As UInt32
    Public Declare Function CreateDirectory Lib "kernel32" Alias "CreateDirectoryW" ( _
        <MarshalAs(UnmanagedType.LPTStr)> ByVal lpPathName As String, _
        <MarshalAs(UnmanagedType.Struct)> ByRef lpSecurityAttributes As SECURITY_ATTRIBUTES) As Integer
    Public Declare Function MoveFile Lib "kernel32" Alias "MoveFileW" ( _
        <MarshalAs(UnmanagedType.LPTStr)> ByVal lpExistingFileName As String, _
        <MarshalAs(UnmanagedType.LPTStr)> ByVal lpNewFileName As String) As Integer

    Function GetINIString(ByRef strSection As String, ByRef strKey As String, ByRef strINIFile As String) As String
        Dim strWork As StringBuilder = New StringBuilder(500)

        GetPrivateProfileString(strSection, strKey, "", strWork, 500, strINIFile)
        GetINIString = strWork.ToString
    End Function
End Module
